'\"
'\" Copyright (c) 1997 by Sun Microsystems, Inc.
'\"
'\" See the file "license.terms" for information on usage and redistribution
'\" of this file, and for a DISCLAIMER OF ALL WARRANTIES.
'\" 
'\" RCS: @(#) $Id: binary.ru.n,v 1.1.1.1 2003/10/16 19:01:11 alex Exp $
'\" 
.so man.macros
.TH binary n 8.0 Tcl "Tcl Built-In Commands"
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
binary \-       
.SH SYNOPSIS
\fBbinary format \fI\fR ?\fI  ...\fR?
.br
\fBbinary scan \fI \fR ?\fI  ...\fR?
.BE

.SH DESCRIPTION
.PP
      .
   \fBbinary format\fR   
  Tcl . ,   16  22, 
 ,    
 ,    ң  . 
  \fBbinary scan\fR    -
           Tcl
.

.SH "BINARY FORMAT"
.PP
 \fBbinary format\fR   ,  
    \fI\fR,  
    .   
 .
.PP
 \fI\fR    
    , ̣  ( 
).       ,  
   - \fIcount\fR.  
   \fI\fR   
.     ,   
 .  \fIcount\fR  ,  
   ң  .  
\fIcount\fR ,      
   *,     
  .   \fI\fR 
      ,  
.
.PP
 ģ ,     
   :
.CS
\fBbinary format d3d {1.0 2.0 3.0 4.0} 0.1\fR
.CE
.PP
  -   ң ,     
 (d3)   ,       
  .     
  (d).     
 : 1.0, 2.0, 3.0  0.1.
.PP
  \fIcount\fR    
 ,        
  ,     Σ.  
 - 0, ..   .      
 :
.IP \fBa\fR 5
    \fIcount\fR   . 
\fI\fR    \fIcount\fR ,   
        . 
\fI\fR ,     ,  
 .   \fIcount\fR   
 *,    \fI\fR  . 
 \fIcount\fR  ,     .
 :
.RS
.CS
\fBbinary format a7a*a alpha bravo charlie\fR
.CE
 ,  \fBalpha\\000\\000bravoc\fR.
.RE
.IP \fBA\fR 5
    \fBa\fR,   , 
     ,  
. , :
.RS
.CS
\fBbinary format A6A*A alpha bravo charlie\fR
.CE
  \fBalpha bravoc\fR.
.RE
.IP \fBb\fR 5
 ,   \fIcount\fR   c 
 -   . \fI\fR
     1  0.
     -,  
      -. 
 \fI\fR  ,  \fIcount\fR ,
      . 
 \fI\fR  ,  \fIcount\fR
 ,    .  
\fIcount\fR     *,   
\fI\fR  .   
     ,    
   .   :
.RS
.CS
\fBbinary format b5b* 11100 111000011010\fR
.CE
   \fB\\x07\\x87\\x05\fR.
.RE
.IP \fBB\fR 5
    \fBb\fR   , 
    -. ,
.RS
.CS
\fBbinary format B5B* 11100 111000011010\fR
.CE
   \fB\\xe0\\xe1\\xa0\fR.
.RE
.IP \fBh\fR 5
 ,  \fIcount\fR   
 -     .
\fI\fR      
``01234567890abcdefABCDEF''.    
    -,  
     -
  .  \fI\fR   \fIcount\fR
,        . 
\fI\fR    ,  , 
   .   \fIcount\fR  
  *,    \fI\fR  .
  \fIcount\fR  ,    
 .        
 ,       . ,
.RS
.CS
\fBbinary format h3h* AB def\fR
.CE
   \fB\\xba\\x00\\xed\\x0f\fR.
.RE
.IP \fBH\fR 5
    \fBh\fR   , 
    -   .
,
.RS
.CS
\fBbinary format H3H* ab DEF\fR
.CE
   \fB\\xab\\x00\\xde\\xf0\fR.
.RE
.IP \fBc\fR 5
        .
  \fIcount\fR  ,  \fI\fR  
  ,  \fI\fR  
 ,     \fIcount\fR 
.        
     .  
\fIcount\fR     *,      
 .      , 
\fIcount\fR,    .   
  ,  \fIcount\fR    
. ,
.RS
.CS
\fBbinary format c3cc* {3 -3 128 1} 260 {2 5}\fR
.CE
   \fB\\x03\\xfd\\x80\\x04\\x02\\x05\fR,
 
.CS
\fBbinary format c {2 5}\fR
.CE
 .
.RE
.IP \fBs\fR 5
   \fBc\fR   , 
        
 - (little-endian)   . 
       
    ,     
. ,
.RS
.CS
\fBbinary format s3 {3 -3 258 1}\fR
.CE
   \fB\\x03\\x00\\xfd\\xff\\x02\\x01\fR.
.RE
.IP \fBS\fR 5
    \fBs\fR   , 
        
- (big-endian). ,
.RS
.CS
\fBbinary format S3 {3 -3 258 1}\fR
.CE
   
\fB\\x00\\x03\\xff\\xfd\\x01\\x02\fR.
.RE
.IP \fBi\fR 5
    \fBc\fR   ,  
        
 -   .    
     ң  
  ,      .
,
.RS
.CS
\fBbinary format i3 {3 -3 65536 1}\fR
.CE
   
\fB\\x03\\x00\\x00\\x00\\xfd\\xff\\xff\\xff\\x00\\x00\\x01\\x00\fR
.RE
.IP \fBI\fR 5
    \fBi\fR   ,  
         
  -(big-endian). ,
.RS
.CS
\fBbinary format I3 {3 -3 65536 1}\fR
.CE
   
\fB\\x00\\x00\\x00\\x03\\xff\\xff\\xff\\xfd\\x00\\x01\\x00\\x00\fR
.RE
.IP \fBw\fR 5
.VS 8.4
    \fBc\fR,   , 
   ң    
     - (little-endian).
        
     ,   
  . ,
.RS
.CS
\fBbinary format w 7810179016327718216\fR
.CE
   
\fBHelloTcl\fR
.RE
.IP \fBW\fR 5
    \fBw\fR   , 
   ң    
     - (big-endian).
,
.RS
.CS
\fBbinary format Wc 4785469626960341345 110\fR
.CE
   
\fBBigEndian\fR
.VE
.RE
.IP \fBf\fR 5
    \fBc\fR   , 
         
    - .  
   ,     
      .     
    ,   
    .   
    ,   
FLT_MAX   .   Tcl    
,        
    . ,  
 Windows,    Intel Pentium 
.RS
.CS
\fBbinary format f2 {1.6 3.4}\fR
.CE
   
\fB\\xcd\\xcc\\xcc\\x3f\\x9a\\x99\\x59\\x40\fR.
.RE
.IP \fBd\fR 5
    \fBf\fR   , 
          
   - . , 
  Windows,    Intel Pentium

.RS
.CS
\fBbinary format d1 {1.6}\fR
.CE
   
\fB\\x9a\\x99\\x99\\x99\\x99\\x99\\xf9\\x3f\fR.
.RE
.IP \fBx\fR 5
 \fIcount\fR ,     . 
 \fIcount\fR  ,    , 
.   \fIcount\fR     *, 
 .     .
, 
.RS
.CS
\fBbinary format a3xa3x2a3 abc def ghi\fR
.CE
   
\fBabc\\000def\\000\\000ghi\fR.
.RE
.IP \fBX\fR 5
       \fIcount\fR .  
 \fIcount\fR     *  , 
   ,      
0,         
 .   \fIcount\fR  ,  
    .    
. , 
.RS
.CS
\fBbinary format a3X*a3X2a3 abc def ghi\fR
.CE
 \fBdghi\fR.
.RE
.IP \fB@\fR 5
       ,  
 \fIcount\fR.  0     
.  \fIcount\fR   ,  
  ,     
        
.    \fIcount\fR     *, 
     .   \fIcount\fR 
,    .    
\fI\fR. , 
.RS
.CS
\fBbinary format a5@2a1@*a3@10a1 abcde f ghi j\fR
.CE
 \fBabfdeghi\\000\\000j\fR.
.RE

.SH "BINARY SCAN"
.PP
 \fBbinary scan\fR      
  ޣ . \fI\fR  
 ,  \fI\fR    , 
  .  \fI\fR 
 ,    ޣ  \fI\fR
.
.PP
     \fBbinary format\fR, \fI\fR 
       ,
̣  (  ).   
   ,      -
\fIcount\fR.     
\fI\fR    ,    
 ޣ    . 
   ,    
 .  \fIcount\fR  ,  
   ң  .   \fIcount\fR
,        
 \fB*\fR,      
  .      
  ,   , 
    ,   \fBbinary scan\fR
     Σ .
      ͣ
,   .
.PP
,   ,  ģ   \fBbinary format\fR,
       
   scan:
.CS
\fBbinary scan $bytes s3s first second\fR
.CE
.PP
,   \fIbytes\fR   
 .  ģ   
\fIfirst\fR ,   ң   ,
 \fIsecond\fR    .
  \fIbytes\fR     (.. 
 ),    \fIsecond\fR 
,  \fIbytes\fR     (.. 
 ),    \fIfirst\fR 
.  ,  :
.CS
\fBputs [binary scan abcdefg s3s first second]\fR
\fBputs $first\fR
\fBputs $second\fR
.CE
 (    \fIfirst\fR  \fIsecond\fR 
   )  :
.CS
\fB1\fR
\fB25185 25699 26213\fR
\fIcan't read "second": no such variable\fR
.CE
.PP
\fI\fR : ,    
\fIc\fR, \fIs\fR  \fIS\fR (  \fIi\fR  \fII\fR 
ң )    
long. ޣ,      (0x80  
 char, 0x8000  short, 0x80000000  int)  :
.CS
\fBset signShort [binary format s1 0x8000]\fR
\fBbinary scan $signShort s1 val; \fI# val == 0xFFFF8000\fR
.CE
    ,    
    . ,  
  unsigned shoft    :
.CS
\fBset val [expr {$val & 0xFFFF}]; \fI# val == 0x8000\fR
.CE
.PP
  \fIcount\fR    
       .  
 - 0, ..   .       
 :
.IP \fBa\fR 5
 -    \fIcount\fR.   \fIcount\fR
    *,      
\fI\fR    .   \fIcount\fR 
,      . ,
.RS
.CS
\fBbinary scan abcde\\000fghi a6a10 var1 var2\fR
.CE
 \fB1\fR,    \fBvar1\fR  
,  \fBabcde\\000\fR,   
\fBvar2\fR   .
.RE
.IP \fBA\fR 5
    \fBa\fR,   , 
    -    
 . , 
.RS
.CS
\fBbinary scan "abc efghi  \\000" A* var1\fR
.CE
 \fB1\fR,     \fBvar1\fR  
 \fBabc efghi\fR.
.RE
.IP \fBb\fR 5
   ,   \fIcount\fR  
  -    
 ``1''  ``0''.       
 ,         
   .     
 .   \fIcount\fR   
 *,       \fI\fR
.   \fIcount\fR  ,  
   . , 
.CS
\fBbinary scan \\x07\\x87\\x05 b5b* var1 var2\fR
.CE
 \fB2\fR,    \fBvar1\fR  
 \fB11100\fR,   \fBvar2\fR   
\fB1110000110100000\fR.
.RE
.IP \fBB\fR 5
    \fBb\fR,   ,  
    -   .
, 
.RS
.CS
\fBbinary scan \\x70\\x87\\x05 B5B* var1 var2\fR
.CE
 \fB2\fR,    \fBvar1\fR   
\fB01110\fR,   \fBvar2\fR   
\fB1000011100000101\fR.
.RE
.IP \fBh\fR 5
   ,   \fIcount\fR
    -  
     ``0123456789abcdef''. 
       ,  
     - 
 .       . 
 \fIcount\fR     *,   
    \fI\fR . 
 \fIcount\fR  ,     
 . , 
.RS
.CS
\fBbinary scan \\x07\\x86\\x05 h3h* var1 var2\fR
.CE
 \fB2\fR,    \fBvar1\fR  
 \fB706\fR,   \fBvar2\fR   
\fB50\fR.
.RE
.IP \fBH\fR 5
    \fBH\fR,   , 
      -.
, 
.RS
.CS
\fBbinary scan \\x07\\x86\\x05 H3H* var1 var2\fR
.CE
 \fB2\fR,    \fBvar1\fR  
 \fB078\fR,   \fBvar2\fR   
\fB05\fR.
.RE
.IP \fBc\fR 5
   \fIcount\fR     
      .  
\fIcount\fR     *,     
 \fI\fR  .   \fIcount\fR
 ,        .
, 
.RS
.CS
\fBbinary scan \\x07\\x86\\x05 c2c* var1 var2\fR
.CE
 \fB2\fR,    \fBvar1\fR  
 \fB7 -122\fR,   \fBvar2\fR  
 \fB5\fR. ,     ,   
       
:
.CS
\fBexpr ( $num + 0x100 ) % 0x100\fR
.CE
.RE
.IP \fBs\fR 5
   \fIcount\fR   
     - (little-endian). 
      . 
 \fIcount\fR     *,   
   \fI\fR  .  
\fIcount\fR  ,     
 . , 
.RS
.CS
\fBbinary scan \\x05\\x00\\x07\\x00\\xf0\\xff s2s* var1 var2\fR
.CE
 \fB2\fR,    \fBvar1\fR  
 \fB5 7\fR,   \fBvar2\fR   
\fB-16\fR. ,     ,   
      
 :
.CS
\fBexpr ( $num + 0x10000 ) % 0x10000\fR
.CE
.RE
.IP \fBS\fR 5
    \fBs\fR,   , 
   \fIcount\fR   
     - (big-endian).
, 
.RS
.CS
\fBbinary scan \\x00\\x05\\x00\\x07\\xff\\xf0 S2S* var1 var2\fR
.CE
 \fB2\fR,    \fBvar1\fR  
 \fB5 7\fR,   \fBvar2\fR   
\fB-16\fR.
.RE
.IP \fBi\fR 5
   \fIcount\fR  
      - (little-endian).
       .  
 \fIcount\fR     *,   
   \fI\fR  .  
\fIcount\fR  ,    
  . , 
.RS
.CS
\fBbinary scan \\x05\\x00\\x00\\x00\\x07\\x00\\x00\\x00\\xf0\\xff\\xff\\xff i2i* var1 var2\fR
.CE
 \fB2\fR,    \fBvar1\fR  
 \fB5 7\fR,   \fBvar2\fR   
\fB-16\fR. ,         
  Tcl   .
.RE
.IP \fBI\fR 5
    \fBI\fR,   , 
   \fIcount\fR     
  - (big-endian). , 
.RS
.CS
\fBbinary scan \\x00\\x00\\x00\\x05\\x00\\x00\\x00\\x07\\xff\\xff\\xff\\xf0 I2I* var1 var2\fR
.CE
 \fB2\fR,    \fBvar1\fR  
 \fB5 7\fR,   \fBvar2\fR   
\fB-16\fR.
.RE
.IP \fBw\fR 5
.VS 8.4
   \fIcount\fR ң
       -
(little-endian).      
 .   \fIcount\fR     *, 
    .   \fIcount\fR 
,     ң
. , 
.RS
.CS
\fBbinary scan \\x05\\x00\\x00\\x00\\x07\\x00\\x00\\x00\\xf0\\xff\\xff\\xff wi* var1 var2\fR
.CE
 \fB2\fR,    \fBvar1\fR  
 \fB30064771077\fR,   \fBvar2\fR  
 \fB-16\fR. ,        
   Tcl   .
.RE
.IP \fBW\fR 5
    \fBw\fR   , 
   \fIcount\fR ң
     - (big-endian). ,

.RS
.CS
\fBbinary scan \\x00\\x00\\x00\\x05\\x00\\x00\\x00\\x07\\xff\\xff\\xff\\xf0 WI* var1 var2\fR
.CE
 \fB2\fR,    \fBvar1\fR  
 \fB21474836487\fR,   \fBvar2\fR  
 \fB-16\fR.
.VE
.RE
.IP \fBf\fR 5
   \fIcount\fR    
   - .  
      . 
 \fIcount\fR     *,   
  .   \fIcount\fR  , 
      .    
      , ..
     .   
     ,   
 ̣     .  , 
  Windows,    Intel Pentium

.RS
.CS
\fBbinary scan \\x3f\\xcc\\xcc\\xcd f var1\fR
.CE
 \fB1\fR,    \fBvar1\fR   
\fB1.6000000238418579\fR.
.RE
.IP \fBd\fR 5
    \fBf\fR,   , 
   \fIcount\fR    
   - . ,  
 Windows,    Intel Pentium 
.RS
.CS
\fBbinary scan \\x9a\\x99\\x99\\x99\\x99\\x99\\xf9\\x3f d var1\fR
.CE
 \fB1\fR,    \fBvar1\fR    
\fB1.6000000000000001\fR.
.RE
.IP \fBx\fR 5
   \fI\fR ң  \fIcount\fR . 
 \fIcount\fR     *  , 
       ,  
     \fI\fR.  
\fIcount\fR  ,       ң.
    . , 
.RS
.CS
\fBbinary scan \\x01\\x02\\x03\\x04 x2H* var1\fR
.CE
 \fB1\fR,    \fBvar1\fR  
 \fB0304\fR.
.RE
.IP \fBX\fR 5
   \fI\fR   \fIcount\fR .  
 \fIcount\fR     *   
 ,      0, .. 
      \fI\fR.  
\fIcount\fR  ,       .
    . , 
.RS
.CS
\fBbinary scan \\x01\\x02\\x03\\x04 c2XH* var1 var2\fR
.CE
 \fB2\fR,    \fBvar1\fR  
 \fB1 2\fR,   \fBvar2\fR   
\fB020304\fR
.RE
.IP \fB@\fR 5
    ,   
\fIcount\fR,   .  0    
\fI\fR.  \fIcount\fR   ,  
   ,     
.   \fIcount\fR  ,   .
, 
.RS
.CS
\fBbinary scan \\x01\\x02\\x03\\x04 c2@1H* var1 var2\fR
.CE
 \fB2\fR,    \fBvar1\fR  
 \fB1 2\fR,   \fBvar2\fR   
\fB020304\fR.
.RE

.SH "PLATFORM ISSUES"
      
     .  
\fBtcl_platform\fR   \fBbyteOrder\fR   
      .

.SH "SEE ALSO"
format(n), scan(n), tclvars(n)

.SH KEYWORDS
, , , binary, format, scan
